



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>javascript变量提升</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">javascript变量提升</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-26 11:27:43 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>提升</strong>是一种将变量和函数的声明移到函数作用域（如果不在任何函数内的话就是全局作用域）最顶部的机制。</p>
<p>提升影响了变量的生命周期，一个变量的生命周期包含3个阶段：</p>
<p><strong>声明&mdash;&mdash;</strong>创建一个新变量，例如var myValue；</p>
<p><strong>初始化&mdash;&mdash;</strong>用一个值初始化变量，例如myValue=150；</p>
<p><strong>使用&mdash;&mdash;</strong>使用变量的值，例如alert（myValue）。</p>
<p>javascript并没有严格遵循这个顺序，因此提供了更多的灵活性。比如：函数的使用可以在声明之前。</p>
<p>这是因为javascript的函数声明会被提升到作用域顶部。</p>
<p>变量提升在不同方面的影响也不同：</p>
<p>变量声明：使用var ，let ，const关键字</p>
<p>函数声明：使用function（）{......}语法</p>
<p>类声明：使用class关键字</p>
<p>函数声明在函数作用域内创建并初始化一个变量。默认情况下，声明但是未初始化的变量的值是undefined。</p>
<p>1.提升var：使用var声明的变量会被提升到所在函数作用域的顶部，如果在声明之前访问该变量，它的值会是undefined。虽然它的声明提升了，但是它的赋值没有提升到函数作用域顶部，依然留在原地。</p>
<div>
<pre class="prettyprint linenums">function sum(a,b){<br />
var myString;             //提升到顶部<br />
console.log(myString);           //undefined<br />
myString="HelloWorld";             //赋值不受影响<br />
console.log(myStriing);              //&lsquo;HelloWorld&rsquo;<br />
return a+b;<br />
}</pre>
</div>
<p>2.块级作用域变量：let</p>
<p>let声明在块级作用域内创建并初始化一个变量：默认情况下，声明但是未初始化的变量的值是undefined。</p>
<p>let是ECMAScript6引入的一个巨大的改进，它允许代码在代码块的级别上保持模块性和封装性；</p>
<p>使用let定义的变量会被提升到代码块的顶部。但是如果在声明前访问该变量，javascript会抛出异常ReferenceError:is not defined。</p>
<p>在声明语句一直到代码库的顶部，变量都好像在一个临时死亡区间中一样，不能被访问。</p>
<div>
<pre class="prettyprint linenums">function isTruthy(value){<br />
var myVariable='Value 1';<br />
console.log(myVariable);      //Value1<br />
if(value){<br />
console.log(myVariable);    //ReferenceError:myVariable is not defined,临时死亡区<br />
let myVariable='Value 2';<br />
console.log(myVariable);      //Value 2<br />
return true;<br />
}<br />
}</pre>
</div>
<p>以上代码可以确认let变量确实被提升了。<br />let在块级作用域内提升保护了变量不受外层作用域影响。先声明，后使用。</p>
<p>3.常量const</p>
<p>常量声明在块级作用域内创建并初始化一个常量：当声明一个变量时，必须在同一条语句中对该变量进行初始化。在声明与初始化之后，变量的值不能被修改。</p>
<p>使用const定义的常量会被提升到代码块的顶部。由于存在临时死亡区间，常量在声明之前不能被访问。常量提升效果与let声明变量的效果相同。</p>
<p>4.函数声明：函数声明使用提供的名称和参数创建一个函数</p>
<p>函数声明的提升允许你在所属作用域内任何地方使用该函数，即使在声明之前也可以。函数可以在当前作用域或子作用域内的任何地方访问。</p>
<p>注意：函数声明function(){....}和函数表达式var=function(){.....}之间的区别</p>
<p>5.类声明</p>
<p>类声明会被提升到块级作用域的顶部。但是如果你在声明前使用类，javascript会抛出异常。先声明类，然后创建实例。与let的提升效果类似。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7goyeq.html">softwareTesting&lowbar;work2&lowbar;question1</a>
		</li>
						<li><a href="https://www.batexi.com/a/39repp7q.html">5&period;9-3 用正则表达式判断字符串text是否为合法的手机号</a>
		</li>
						<li><a href="https://www.batexi.com/a/4955rme9.html">Git Shell 安装版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1ynod9.html">Quartz&period;net一个简要示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vdxem8.html">Linq 和 EF Contains示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jejyo8.html">ASUS T100TA 换屏要记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojpo61q.html">axure 预览&amp;quot&semi;HTTP&sol;1&period;1 302 Found&amp;quot&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj00519.html">Effective C&plus;&plus; &mdash;&mdash;让自己习惯C&plus;&plus;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rrmwj9.html">PHP引用&lpar;&amp;amp&semi;&rpar;练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25klw3q.html">filter 实现登录状态控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jkg4nq.html">四、Python导入自己写的包报错：没有该包如何解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j6e1eq.html">LoadRunner 11安装Micosoft Visual C&plus;&plus; 2005 SP1时提示命令行选项语法错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw4lz78.html">spring事务管理&lpar;详解和实例&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwldlk39.html">【洛谷P2504】聪明的猴子 最小瓶颈树</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ez40k9.html">js未分类</a>
		</li>
						<li><a href="https://www.batexi.com/a/8konlxrq.html">【第十九章】 springboot &plus; hystrix（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnwovgq.html">Spring Security构建Rest服务-1000-使用SpringSocial开发第三方登录之大白话OAuth协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emwzxj9.html">Fiddler Web Debugger的代理功能（图文详解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k63nvq.html">Go&lowbar;16：GoLang中flag标签使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmx6e49.html">CF 1008C Reorder the Array</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxnxyvz8.html">MailSystem&period;NET Gmail IMAP讀取信件</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xyzrv8.html">LightOJ 1341  Aladdin and the Flying Carpet 数学</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm7w119.html">hdu-5364       Distribution money</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e12rnj9.html">HW输入字符串长度，字符串，计数m。从前往后计数，当数到m个元素时，m个元素出列，同时将该元素赋值给m，然后从下一个数计数循环，直到所有数字都出列，给定的数全部为大于0的数字。输出出队队列。</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k14d0j9.html">LCD platform&lowbar;device&lpar;s5pv210&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjev479.html">Fixing ssh login long delay</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xyyd68.html">EGit插件安装（附Eclipse版本对应表）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdellxj9.html">HW5&period;17</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m3wykq.html">Shell的那些事儿</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1xpv39.html">delphi 默认字体修改</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
